precision mediump float; 
varying vec2 textureCoordinate; 
varying vec2 leftTextureCoordinate;
varying vec2 rightTextureCoordinate;

varying vec2 topTextureCoordinate;
varying vec2 topLeftTextureCoordinate;
varying vec2 topRightTextureCoordinate;

varying vec2 bottomTextureCoordinate;
varying vec2 bottomLeftTextureCoordinate;
varying vec2 bottomRightTextureCoordinate;

uniform sampler2D s_texture;

void main()
{
    float bottomLeftIntensity = texture2D(s_texture, bottomLeftTextureCoordinate).r;
    float topRightIntensity = texture2D(s_texture, topRightTextureCoordinate).r;
    float topLeftIntensity = texture2D(s_texture, topLeftTextureCoordinate).r;
    float bottomRightIntensity = texture2D(s_texture, bottomRightTextureCoordinate).r;
    float leftIntensity = texture2D(s_texture, leftTextureCoordinate).r;
    float rightIntensity = texture2D(s_texture, rightTextureCoordinate).r;
    float bottomIntensity = texture2D(s_texture, bottomTextureCoordinate).r;
    float topIntensity = texture2D(s_texture, topTextureCoordinate).r;
    float h = -topLeftIntensity - 2.0 * topIntensity - topRightIntensity + bottomLeftIntensity + 2.0 * bottomIntensity + bottomRightIntensity;
    float v = -bottomLeftIntensity - 2.0 * leftIntensity - topLeftIntensity + bottomRightIntensity + 2.0 * rightIntensity + topRightIntensity;

    float mag = length(vec2(h, v));

    gl_FragColor = vec4(vec3(mag), 1.0);
}