attribute vec4 position;
attribute vec4 inputTextureCoordinate;

uniform highp float texelWidth; 
uniform highp float texelHeight; 

uniform mat4 uMVPMatrix;
uniform mat4 textureTransform;
varying vec2 textureCoordinate;
varying vec2 leftTextureCoordinate;
varying vec2 rightTextureCoordinate;

varying vec2 topTextureCoordinate;
varying vec2 topLeftTextureCoordinate;
varying vec2 topRightTextureCoordinate;

varying vec2 bottomTextureCoordinate;
varying vec2 bottomLeftTextureCoordinate;
varying vec2 bottomRightTextureCoordinate;

void main()
{
    gl_Position = position;

    vec2 widthStep = vec2(texelWidth, 0.0);
    vec2 heightStep = vec2(0.0, texelHeight);
    vec2 widthHeightStep = vec2(texelWidth, texelHeight);
    vec2 widthNegativeHeightStep = vec2(texelWidth, -texelHeight);

    textureCoordinate = (textureTransform * inputTextureCoordinate).xy;
    leftTextureCoordinate = (textureTransform * inputTextureCoordinate).xy - widthStep;
    rightTextureCoordinate = (textureTransform * inputTextureCoordinate).xy + widthStep;

    topTextureCoordinate = (textureTransform * inputTextureCoordinate).xy - heightStep;
    topLeftTextureCoordinate = (textureTransform * inputTextureCoordinate).xy - widthHeightStep;
    topRightTextureCoordinate = (textureTransform * inputTextureCoordinate).xy + widthNegativeHeightStep;

    bottomTextureCoordinate = (textureTransform * inputTextureCoordinate).xy + heightStep;
    bottomLeftTextureCoordinate = (textureTransform * inputTextureCoordinate).xy - widthNegativeHeightStep;
    bottomRightTextureCoordinate = (textureTransform * inputTextureCoordinate).xy + widthHeightStep;
}